const Mesa = require('vendor/Mesa.js');
const ShopifyGraphql = require('vendor/ShopifyGraphql.js');
const Shopify= require('vendor/Shopify.js');

/**
 * A Mesa Script exports a class with a script() method.
 */
module.exports = new class {
  script = (payload, context) => {
    let vars = context.steps;
    
    let query = `
      mutation createWebhook($callback: URL!) {
        webhookSubscriptionCreate(
          topic: PRODUCTS_UPDATE,
          webhookSubscription: {
            includeFields: [
              "id",
              "tags"
            ]
            callbackUrl: $callback,
          }
        ) {
          webhookSubscription {
            id
          }
          userErrors {
            message
            field
          }
        }
      }
    `;

    const r = ShopifyGraphql.send(query, {
      "callback": "https://webhooks.getmesa.com/v1/kalen-jordan-dev/trigger-webhook/65dc8dcf7a348bcac106f8b8/65dc8ddc6cdd6690c50abf2b.json?apikey=pobbFlA9BN73tE4gkbUsb5DLnZnwfIKi8g8UtM7U"
    }, {}, 'admin/api/2023-10/graphql.json');

    if (r.data.webhookSubscriptionCreate.userErrors.length) {
      throw new Error(JSON.stringify(r.data.webhookSubscriptionCreate.userErrors));
    }

    Mesa.output.next({"response": r.data});
  }
}
