const Mesa = require('vendor/Mesa.js');
const ShopifyGraphql = require('vendor/ShopifyGraphql.js');
const Shopify= require('vendor/Shopify.js');

/**
 * A Mesa Script exports a class with a script() method.
 */
module.exports = new class {
  script = (payload, context) => {
    let vars = context.steps;
    
    let query = `
    mutation deleteWebhook($id:ID!) {
      webhookSubscriptionDelete(id:$id) {
        deletedWebhookSubscriptionId
        userErrors {
          message
          field
        }    
      } 
    }
    `;

    const r = ShopifyGraphql.send(query, {
      "id": "gid://shopify/WebhookSubscription/1478592495937"
    }, {}, 'admin/api/2023-10/graphql.json');

    if (r.data.webhookSubscriptionDelete.userErrors.length) {
      throw new Error(JSON.stringify(r.data.webhookSubscriptionDelete.userErrors));
    }

    Mesa.output.next({"response": r.data});
  }
}
